<?php
class Paging {
    var $records_per_page;
    var $total_records;
    var $current_page;
    var $url;

    function Paging($total_records, $records_per_page, $current_page, $url) {
        $this->total_records = $total_records;
        $this->records_per_page = $records_per_page;
        if(!isset ($current_page)) {
            $current_page = 1;
        }
        $this->current_page = $current_page;
        // TODO: check page is within records..
        $this->url = $url;
    }

    function get_start_record() {
        return ($this->current_page-1) * $this->records_per_page;
    }

    function get_start_record_display() {
        return $this->get_start_record() +1;
    }

    function get_end_record_display() {
        $end_record = $this->get_start_record() + $this->records_per_page;
        if($end_record>$this->total_records) {
            $end_record = $this->total_records;
        }
        return $end_record;
    }

    function get_total_pages() {
        $total_pages = intval($this->total_records/$this->records_per_page);
        if($this->total_records%$this->records_per_page>0) {
            $total_pages++;
        }
        return $total_pages;
    }

    function get_next_page() {
        if($this->current_page>=($this->get_total_pages())) {
            return -1;
        }else {
            return $this->current_page+1;
        }
    }

    function get_previous_page() {
        if($this->current_page<=1) {
            return -1;
        } else {
            return $this->current_page-1;
        }
    }

}
?>
