<?php
class Gamatam_Tasks_Widget extends WP_Widget {
    function Gamatam_Tasks_Widget() {
        parent::WP_Widget(false, 'Gamatam Tasks');
    }

    function widget($args, $instance) {
        global $current_user;
        extract($args);
        $description_length = $instance['description_length'];
        $max_tasks = $instance['max_tasks'];
        echo $before_widget;
        if(isset ($current_user) && $current_user->ID>0) {
            echo $before_title.$this->name.$after_title;
            $tasks=$this->get_in_progress_tasks($max_tasks);
            $this->display_tasks($tasks, 'In Progress', $description_length);
            $tasks=$this->get_open_tasks($max_tasks);
            $this->display_tasks($tasks, 'Open', $description_length);
            $tasks=$this->get_test_tasks($max_tasks);
            $this->display_tasks($tasks, 'Testing', $description_length);
            echo '<a href="'.get_bloginfo('url').'/wp-admin/admin.php?page=gamatam_tasks_admin_current_tasks"> Go to Current Tasks</a>';
            ?>
<div id="dialog-form" title="Gamatam Task">
    <style type="text/css">
        #dialog-form{text-align: left;} #dialog-form th{ vertical-align: top}
    </style>
    <table>
        <tr>
            <th>Description</th>
            <td id="dialog_description"></td>
        </tr>
        <tr>
            <th>Status</th>
            <td id="dialog_status"></td>
        </tr>
        <tr>
            <th>Priority</th>
            <td id="dialog_priority"></td>
        </tr>
        <tr>
            <th>Created</th>
            <td id="dialog_created"></td>
        </tr>
        <tr>
            <th>By</th>
            <td id="dialog_created_by"></td>
        </tr>
        <tr>
            <th>Assigned</th>
            <td id="dialog_assigned"></td>
        </tr>
    </table>
</div>
            <?php
        }
        echo $after_widget;
    }

    function display_tasks($tasks, $title, $description_length) {
        global $GT;
        if(count($tasks)>0) {
            echo '<strong>'.$title.':</strong>';
            echo '<ul>';
            foreach ($tasks as $task) {
                echo '<li title="'.stripslashes($GT->get_description_subject($task->description)).'">';
                echo '<a href="#" onclick="showTask('.$task->id.'); return false">';
                echo stripslashes($GT->get_description_subject($task->description, $description_length));
                echo '</a>';
                echo '</li>';
            }
            echo '</ul>';
        }
    }

    function update($new_instance, $old_instance) {
        return $new_instance;
    }

    function form($instance) {
        $defaults = array( 'max_tasks' => 10, 'description_length' => 24);
        $instance = wp_parse_args( (array) $instance, $defaults );
        $max_tasks = $instance['max_tasks'];
        $description_length = $instance['description_length'];
        ?>
<p><label for="<?php echo $this->get_field_id('max_tasks'); ?>"><?php _e('Number of Tasks Per Status:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('max_tasks'); ?>" name="<?php echo $this->get_field_name('max_tasks'); ?>" type="text" value="<?php echo $max_tasks; ?>" /></label></p>
<p><label for="<?php echo $this->get_field_id('description_length'); ?>"><?php _e('Length of Description to Display:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('description_length'); ?>" name="<?php echo $this->get_field_name('description_length'); ?>" type="text" value="<?php echo $description_length; ?>" /></label></p>
        <?php
    }

    function get_open_tasks($max_tasks) {
        return $this->get_tasks_by_status(1, $max_tasks);
    }

    function get_in_progress_tasks($max_tasks) {
        return $this->get_tasks_by_status(2, $max_tasks);
    }

    function get_test_tasks($max_tasks) {
        return $this->get_tasks_by_status(3, $max_tasks);
    }

    function get_tasks_by_status($status, $max_tasks) {
        global $wpdb, $GT;
        $table_name = $GT->get_table_name('tasks');
        $tasks_array = $wpdb->get_results('SELECT id, description FROM '.$table_name.' where status_id='.$status.' order by priority_id desc limit '.$max_tasks);
        return $tasks_array;
    }

}
?>
